Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.2.0.Final
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.impl.domain.variable.inverserelation
Class ExternalizedSingletonInverseVariableSupply

    java.lang.Object
      org.optaplanner.core.impl.domain.variable.inverserelation.ExternalizedSingletonInverseVariableSupply

All Implemented Interfaces:
  SingletonInverseVariableSupply, StatefulVariableListener<Object>, VariableListener<Object>, Supply

    public class ExternalizedSingletonInverseVariableSupply

extends Object
implements StatefulVariableListener<Object>, SingletonInverseVariableSupply

Alternative to `SingletonInverseVariableListener`.

Field Summary
`protected Map<Object,Set<Object>>` | `inverseEntitySetMap`
`protected VariableDescriptor` | `sourceVariableDescriptor`

Constructor Summary
`ExternalizedSingletonInverseVariableSupply(VariableDescriptor sourceVariableDescriptor)`

Method Summary
`void` | `afterEntityAdded(ScoreDirector scoreDirector, Object entity)`
`void` | `afterEntityRemoved(ScoreDirector scoreDirector, Object entity)`
`void` | `afterVariableChanged(ScoreDirector scoreDirector, Object entity)`
`void` | `beforeEntityAdded(ScoreDirector scoreDirector, Object entity)`
`void` | `beforeEntityRemoved(ScoreDirector scoreDirector, Object entity)`
`void` | `beforeVariableChanged(ScoreDirector scoreDirector, Object entity)`
`void` | `clearWorkingSolution(ScoreDirector scoreDirector)`
`Object` | `getInverseSingleton(Object value)` If entity1.varA = x then the inverse of x is entity1.
`VariableDescriptor` | `getSourceVariableDescriptor()`
`protected void` | `insert(ScoreDirector scoreDirector, Object entity)`
`void` | `resetWorkingSolution(ScoreDirector scoreDirector)`
`protected void` | `retract(ScoreDirector scoreDirector, Object entity)`
`String` | `toString()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### sourceVariableDescriptor

    protected final VariableDescriptor sourceVariableDescriptor

### inverseEntitySetMap

    protected Map<Object,Set<Object>> inverseEntitySetMap

Constructor Detail

### ExternalizedSingletonInverseVariableSupply

    public ExternalizedSingletonInverseVariableSupply(VariableDescriptor sourceVariableDescriptor)

Method Detail

### getSourceVariableDescriptor

    public VariableDescriptor getSourceVariableDescriptor()

  Specified by:
    `getSourceVariableDescriptor` in interface `StatefulVariableListener<Object>`

### resetWorkingSolution

    public void resetWorkingSolution(ScoreDirector scoreDirector)

  Specified by:
    `resetWorkingSolution` in interface `StatefulVariableListener<Object>`

### clearWorkingSolution

    public void clearWorkingSolution(ScoreDirector scoreDirector)

  Specified by:
    `clearWorkingSolution` in interface `StatefulVariableListener<Object>`

### beforeEntityAdded

    public void beforeEntityAdded(ScoreDirector scoreDirector,
                                  Object entity)

  Specified by:
    `beforeEntityAdded` in interface `VariableListener<Object>`

### afterEntityAdded

    public void afterEntityAdded(ScoreDirector scoreDirector,
                                 Object entity)

  Specified by:
    `afterEntityAdded` in interface `VariableListener<Object>`

### beforeVariableChanged

    public void beforeVariableChanged(ScoreDirector scoreDirector,
                                      Object entity)

  Specified by:
    `beforeVariableChanged` in interface `VariableListener<Object>`

### afterVariableChanged

    public void afterVariableChanged(ScoreDirector scoreDirector,
                                     Object entity)

  Specified by:
    `afterVariableChanged` in interface `VariableListener<Object>`

### beforeEntityRemoved

    public void beforeEntityRemoved(ScoreDirector scoreDirector,
                                    Object entity)

  Specified by:
    `beforeEntityRemoved` in interface `VariableListener<Object>`

### afterEntityRemoved

    public void afterEntityRemoved(ScoreDirector scoreDirector,
                                   Object entity)

  Specified by:
    `afterEntityRemoved` in interface `VariableListener<Object>`

### insert

    protected void insert(ScoreDirector scoreDirector,
                          Object entity)

### retract

    protected void retract(ScoreDirector scoreDirector,
                           Object entity)

### getInverseSingleton

    public Object getInverseSingleton(Object value)

  Description copied from interface: `SingletonInverseVariableSupply`
  If entity1.varA = x then the inverse of x is entity1.

  Specified by:
    `getInverseSingleton` in interface `SingletonInverseVariableSupply`
  Parameters:
    `value` - never null
  Returns:
    sometimes null, an entity for which the planning variable is the planningValue.

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.2.0.Final
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2015 JBoss by Red Hat. All Rights Reserved.